## mingw-w64-qt-creator-16.0.0-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20)

option(BUILD_DESIGNSTUDIO "Build and install design studio plugins, examples and settings." OFF)
if (BUILD_DESIGNSTUDIO)
    list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/dist/branding/qtdesignstudio")
endif()

## Add paths to check for cmake modules:
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(Utils)

env_with_default("QTC_BUILD_WITH_PCH" ENV_QTC_BUILD_WITH_PCH ON)
env_with_default("QTC_WITH_TESTS" ENV_QTC_WITH_TESTS OFF)

option(BUILD_WITH_PCH "Build with precompiled headers" "${ENV_QTC_BUILD_WITH_PCH}")

include(FeatureSummary)
include(QtCreatorIDEBranding RESULT_VARIABLE IDE_BRANDING_FILE)
include(QtCreatorTranslations)
include(QtCreatorDocumentation)
include(QtCreatorAPI)

set(IDE_REVISION FALSE CACHE BOOL "Marks the presence of IDE revision string.")
set(IDE_REVISION_STR "" CACHE STRING "The IDE revision string.")
set(IDE_REVISION_URL "" CACHE STRING "The IDE revision Url string.")

mark_as_advanced(IDE_REVISION IDE_REVISION_STR IDE_REVISION_URL)

project(QtCreator VERSION ${IDE_VERSION})

# Force C++ standard, do not fall back, do not use compiler extensions
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

qtc_handle_compiler_cache_support()
qtc_handle_llvm_linker()

option(BUILD_LINK_WITH_QT "Link with Qt from the parent Qt Creator" OFF)
qtc_link_with_qt()

option(WITH_TESTS "Build Tests" ${ENV_QTC_WITH_TESTS})
add_feature_info("Build tests" ${WITH_TESTS} "")
option(WITH_DEBUG_CMAKE "Enabled CMake project debugging functionality" OFF)
option(SHOW_BUILD_DATE "Show build date in about dialog" OFF)
option(WITH_SANITIZE "Build with sanitizer enabled" OFF)
set(SANITIZE_FLAGS "" CACHE STRING "Sets flags for sanitizer compilation flags used in Debug builds")
add_feature_info("Build with sanitize" ${WITH_SANITIZE} "SANITIZE_FLAGS='${SANITIZE_FLAGS}'")


# merge binary directories of sub projects into top level
set(QTC_MERGE_BINARY_DIR ON)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Set up Qt stuff:
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

if (WITH_TESTS)
  set(QT_TEST_COMPONENT Test)
  set(IMPLICIT_DEPENDS Qt::Test)
endif()

# suppress bogus warning
# warning C4573 requires the compiler to capture 'this' but the current default capture mode does not allow it
# when using QObject::connect in lambda without capturing 'this' - which would lead to warnings
# with other compilers
if(MSVC)
  add_compile_options(/wd4573)
endif()

find_package(Qt6
  ${IDE_QT_VERSION_MIN}
  COMPONENTS Concurrent Core Gui Network PrintSupport Qml Sql Widgets Xml Core5Compat ${QT_TEST_COMPONENT}
  REQUIRED
)

find_package(Qt6 OPTIONAL_COMPONENTS Quick QuickWidgets Designer DesignerComponentsPrivate
                                     Help SerialPort Svg Tools LinguistTools QUIET)

if (QT_VERSION VERSION_GREATER_EQUAL 6.9.0)
  find_package(Qt6 OPTIONAL_COMPONENTS
    CorePrivate
    Core5CompatPrivate
    GuiPrivate
    DesignerComponentsPrivate
    QmlPrivate
    QuickPrivate
    QUIET
  )
endif()

# depending on Qt version and compiler version enable or disable Qml Designer
# can be overwritten by variable WITH_QMLDESIGNER / QTC_WITH_QMLDESIGNER (env)
configure_qml_designer(${Qt6_VERSION})

# hack for Qbs which still supports Qt5 and Qt6
if (TARGET Qt6::Core5CompatPrivate)
    if (CMAKE_VERSION VERSION_LESS 3.18)
        set_property(TARGET Qt6::Core5CompatPrivate PROPERTY IMPORTED_GLOBAL TRUE)
    endif()
    add_library(Qt6Core5CompatPrivate ALIAS Qt6::Core5CompatPrivate)
endif()
if (TARGET Qt6::Core5Compat)
    if (CMAKE_VERSION VERSION_LESS 3.18)
        set_property(TARGET Qt6::Core5Compat PROPERTY IMPORTED_GLOBAL TRUE)
    endif()
    add_library(Qt6Core5Compat ALIAS Qt6::Core5Compat)
endif()

# Common intermediate directory for QML modules which are defined via qt_add_qml_module()
set(QT_QML_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/qml_modules")

# This includes the code that will enable higher compiler warnings level (/W3 for MSVC, -Wall -Wextra for GCC)
# This is controlled by QT_COMPILE_OPTIONS_DISABLE_WARNINGS target property.
include(QtCompilerFlags)

if (MSVC AND QT_FEATURE_static_runtime)
  set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
endif()

find_package(Threads)
find_package(Clang QUIET)

# Crashpad
set(CRASHPAD_BACKEND_URL "$ENV{QTC_CRASHPAD_BACKEND_URL}" CACHE STRING "Crashpad backend URL")
set(BUILD_WITH_CRASHPAD OFF)
# Linux is not supported for now
if(CRASHPAD_BACKEND_URL AND (WIN32 OR APPLE)) # Linux is not supported for now
  find_package(Crashpad QUIET)
  if(TARGET Crashpad::Crashpad)
    set(BUILD_WITH_CRASHPAD ON)
  endif()
endif()
add_feature_info("Build with Crashpad" ${BUILD_WITH_CRASHPAD} "")

function (set_if_target var target)
   if (TARGET "${target}")
     set(_result ON)
   else()
     set(_result OFF)
   endif()
   set(${var} "${_result}" PARENT_SCOPE)
endfunction()

set_if_target(_has_svg_target Qt::Svg)
option(ENABLE_SVG_SUPPORT "Enable SVG support" "${_has_svg_target}")

add_library(OptionalSvg INTERFACE)
if (TARGET Qt::Svg AND ENABLE_SVG_SUPPORT)
  target_link_libraries(OptionalSvg INTERFACE Qt::Svg)
else()
  target_compile_definitions(OptionalSvg INTERFACE QT_NO_SVG)
endif()
install(TARGETS OptionalSvg EXPORT QtCreator)

if (APPLE)
  find_library(FWCoreFoundation CoreFoundation)
  find_library(FWCoreServices CoreServices)
  find_library(FWFoundation Foundation)
  find_library(FWAppKit AppKit)
  find_library(FWIOKit IOKit)
  find_library(FWSecurity Security)
  find_library(FWSystemConfiguration SystemConfiguration)
  find_library(FWWebKit WebKit)
endif()

if (WITH_TESTS)
  enable_testing()
endif()

if (UNIX)
  add_subdirectory(bin)
endif()

add_subdirectory(src)
add_subdirectory(share)
if (NOT BUILD_DESIGNSTUDIO)
    add_subdirectory(dist)
endif()

if (WITH_TESTS)
  add_subdirectory(tests)
endif()

add_subdirectory(doc)

setup_dependencies_component()

feature_summary(INCLUDE_QUIET_PACKAGES WHAT
  PACKAGES_FOUND PACKAGES_NOT_FOUND
  ENABLED_FEATURES DISABLED_FEATURES
)

if (CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR
    AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE.GPL3-EXCEPT")
  # Only for opensource, non-super-repo builds
  add_subdirectory(packaging)
endif()

=== src/plugins/coreplugin/CMakeLists.txt ===
add_qtc_plugin(Core
  DEPENDS Qt::PrintSupport Qt::Qml Qt::Sql Qt::Gui Qt::GuiPrivate TerminalLib qtkeychain
  PUBLIC_DEPENDS Aggregation ExtensionSystem Utils
  SOURCES
    actionmanager/actioncontainer.cpp
    actionmanager/actioncontainer.h
    actionmanager/actioncontainer_p.h
    actionmanager/actionmanager.cpp
    actionmanager/actionmanager.h
    actionmanager/actionmanager_p.h
    actionmanager/command.cpp
    actionmanager/command.h
    actionmanager/command_p.h
    actionmanager/commandmappings.cpp
    actionmanager/commandmappings.h
    actionsfilter.cpp
    actionsfilter.h
    basefilewizard.cpp
    basefilewizard.h
    basefilewizardfactory.cpp
    basefilewizardfactory.h
    core.qrc
    core_global.h
    coreconstants.h
    coreicons.cpp
    coreicons.h
    corejsextensions.cpp
    corejsextensions.h
    coreplugin.cpp
    coreplugin.h
    coreplugintr.h
    credentialquery.cpp
    credentialquery.h
    designmode.cpp
    designmode.h
    dialogs/addtovcsdialog.cpp
    dialogs/addtovcsdialog.h
    dialogs/codecselector.cpp
    dialogs/codecselector.h
    dialogs/externaltoolconfig.cpp
    dialogs/externaltoolconfig.h
    dialogs/filepropertiesdialog.cpp
    dialogs/filepropertiesdialog.h
    dialogs/ioptionspage.cpp
    dialogs/ioptionspage.h
    dialogs/newdialog.cpp
    dialogs/newdialog.h
    dialogs/openwithdialog.cpp
    dialogs/openwithdialog.h
    dialogs/promptoverwritedialog.cpp
    dialogs/promptoverwritedialog.h
    dialogs/readonlyfilesdialog.cpp
    dialogs/readonlyfilesdialog.h
    dialogs/saveitemsdialog.cpp
    dialogs/saveitemsdialog.h
    dialogs/settingsdialog.cpp
    dialogs/settingsdialog.h
    dialogs/shortcutsettings.cpp
    dialogs/shortcutsettings.h
    diffservice.cpp
    diffservice.h
    documentmanager.cpp
    documentmanager.h
    editmode.cpp
    editmode.h
    editormanager/documentmodel.cpp
    editormanager/documentmodel.h
    editormanager/documentmodel_p.h
    editormanager/editorarea.cpp
    editormanager/editorarea.h
    editormanager/editormanager.cpp
    editormanager/editormanager.h
    editormanager/editormanager_p.h
    editormanager/editorview.cpp
    editormanager/editorview.h
    editormanager/editorwindow.cpp
    editormanager/editorwindow.h
    editormanager/ieditor.cpp
    editormanager/ieditor.h
    editormanager/ieditorfactory.cpp
    editormanager/ieditorfactory.h
    editormanager/ieditorfactory_p.h
    editormanager/openeditorsview.cpp
    editormanager/openeditorsview.h
    editormanager/openeditorswindow.cpp
    editormanager/openeditorswindow.h
    editormanager/systemeditor.cpp
    editormanager/systemeditor.h
    editortoolbar.cpp
    editortoolbar.h
    externaltool.cpp
    externaltool.h
    externaltoolmanager.cpp
    externaltoolmanager.h
    fancyactionbar.cpp
    fancyactionbar.h
    fancyactionbar.qrc
    fancytabwidget.cpp
    fancytabwidget.h
    featureprovider.cpp
    featureprovider.h
    fileutils.cpp
    fileutils.h
    find/basetextfind.cpp
    find/basetextfind.h
    find/currentdocumentfind.cpp
    find/currentdocumentfind.h
    find/find.qrc
    find/findplugin.cpp
    find/findplugin.h
    find/findtoolbar.cpp
    find/findtoolbar.h
    find/findtoolwindow.cpp
    find/findtoolwindow.h
    find/highlightscrollbarcontroller.cpp
    find/highlightscrollbarcontroller.h
    find/ifindfilter.cpp
    find/ifindfilter.h
    find/ifindsupport.cpp
    find/ifindsupport.h
    find/itemviewfind.cpp
    find/itemviewfind.h
    find/optionspopup.cpp
    find/optionspopup.h
    find/searchresulttreeitemdelegate.cpp
    find/searchresulttreeitemdelegate.h
    find/searchresulttreeitemroles.h
    find/searchresulttreeitems.cpp
    find/searchresulttreeitems.h
    find/searchresulttreemodel.cpp
    find/searchresulttreemodel.h
    find/searchresulttreeview.cpp
    find/searchresulttreeview.h
    find/searchresultwidget.cpp
    find/searchresultwidget.h
    find/searchresultwindow.cpp
    find/searchresultwindow.h
    find/textfindconstants.h
    findplaceholder.cpp
    findplaceholder.h
    foldernavigationwidget.cpp
    foldernavigationwidget.h
    generalsettings.cpp
    generalsettings.h
    generatedfile.cpp
    generatedfile.h
    helpitem.cpp
    helpitem.h
    helpmanager.cpp
    helpmanager.h
    helpmanager_implementation.h
    icontext.cpp
    icontext.h
    icore.cpp
    icore.h
    idocument.cpp
    idocument.h
    idocumentfactory.cpp
    idocumentfactory.h
    ifilewizardextension.h
    imode.cpp
    imode.h
    inavigationwidgetfactory.cpp
    inavigationwidgetfactory.h
    ioutputpane.cpp
    ioutputpane.h
    iversioncontrol.cpp
    iversioncontrol.h
    iwelcomepage.cpp
    iwelcomepage.h
    iwizardfactory.cpp
    iwizardfactory.h
    jsexpander.cpp
    jsexpander.h
    locator/commandlocator.cpp
    locator/commandlocator.h
    locator/directoryfilter.cpp
    locator/directoryfilter.h
    locator/executefilter.cpp
    locator/executefilter.h
    locator/externaltoolsfilter.cpp
    locator/externaltoolsfilter.h
    locator/filesystemfilter.cpp
    locator/filesystemfilter.h
    locator/ilocatorfilter.cpp
    locator/ilocatorfilter.h
    locator/javascriptfilter.cpp
    locator/javascriptfilter.h
    locator/locator.cpp
    locator/locator.h
    locator/locatorconstants.h
    locator/locatorfiltersfilter.cpp
    locator/locatorfiltersfilter.h
    locator/locatormanager.cpp
    locator/locatormanager.h
    locator/locatorsettingspage.cpp
    locator/locatorsettingspage.h
    locator/locatorwidget.cpp
    locator/locatorwidget.h
    locator/opendocumentsfilter.cpp
    locator/opendocumentsfilter.h
    locator/spotlightlocatorfilter.cpp
    locator/spotlightlocatorfilter.h
    locator/urllocatorfilter.cpp
    locator/urllocatorfilter.h
    loggingviewer.cpp
    loggingviewer.h
    manhattanstyle.cpp
    manhattanstyle.h
    messagebox.cpp
    messagebox.h
    messagemanager.cpp
    messagemanager.h
    mimetypemagicdialog.cpp
    mimetypemagicdialog.h
    mimetypesettings.cpp
    mimetypesettings.h
    minisplitter.cpp
    minisplitter.h
    modemanager.cpp
    modemanager.h
    navigationsubwidget.cpp
    navigationsubwidget.h
    navigationwidget.cpp
    navigationwidget.h
    opendocumentstreeview.cpp
    opendocumentstreeview.h
    outputpane.cpp
    outputpane.h
    outputpanemanager.cpp
    outputpanemanager.h
    outputwindow.cpp
    outputwindow.h
    patchtool.cpp
    patchtool.h
    plugindialog.cpp
    plugindialog.h
    plugininstallwizard.cpp
    plugininstallwizard.h
    progressmanager/futureprogress.cpp
    progressmanager/futureprogress.h
    progressmanager/processprogress.cpp
    progressmanager/processprogress.h
    progressmanager/progressbar.cpp
    progressmanager/progressbar.h
    progressmanager/progressmanager.cpp
    progressmanager/progressmanager.h
    progressmanager/progressmanager_p.h
    progressmanager/progressview.cpp
    progressmanager/progressview.h
    progressmanager/taskprogress.cpp
    progressmanager/taskprogress.h
    rightpane.cpp
    rightpane.h
    secretaspect.cpp
    secretaspect.h
    session.cpp
    session.h
    sessiondialog.cpp
    sessiondialog.h
    sessionmodel.cpp
    sessionmodel.h
    sessionview.cpp
    sessionview.h
    settingsdatabase.cpp
    settingsdatabase.h
    sidebar.cpp
    sidebar.h
    sidebarwidget.cpp
    sidebarwidget.h
    statusbarmanager.cpp
    statusbarmanager.h
    systemsettings.cpp
    systemsettings.h
    terminal/searchableterminal.cpp
    terminal/searchableterminal.h
    textdocument.cpp
    textdocument.h
    themechooser.cpp
    themechooser.h
    vcsmanager.cpp
    vcsmanager.h
    versiondialog.cpp
    versiondialog.h
    welcomepagehelper.cpp
    welcomepagehelper.h
    windowsupport.cpp
    windowsupport.h
  EXPLICIT_MOC dialogs/filepropertiesdialog.h
)

extend_qtc_plugin(Core
  CONDITION SHOW_BUILD_DATE
  DEFINES QTC_SHOW_BUILD_DATE
)

extend_qtc_plugin(Core
  CONDITION WITH_TESTS
  SOURCES
    locator/locator_test.cpp
    locator/locatorfiltertest.cpp
    locator/locatorfiltertest.h
    testdatadir.cpp
    testdatadir.h
)

extend_qtc_plugin(Core
  CONDITION WIN32
  SOURCES progressmanager/progressmanager_win.cpp
)

extend_qtc_plugin(Core
  CONDITION APPLE
  DEPENDS ${FWAppKit}
  SOURCES
    progressmanager/progressmanager_mac.mm
)

extend_qtc_plugin(Core
  CONDITION (NOT WIN32) AND (NOT APPLE)
  SOURCES progressmanager/progressmanager_x11.cpp
)

extend_qtc_plugin(Core
  CONDITION BUILD_WITH_CRASHPAD
  DEFINES ENABLE_CRASHPAD
)

set(FONTS_BASE "${QtCreator_SOURCE_DIR}/src/share/3rdparty/studiofonts/")
qt_add_resources(Core
  CoreWelcomeScreenFonts_rcc
  BASE ${FONTS_BASE}
  PREFIX "studiofonts"
  FILES "${FONTS_BASE}/TitilliumWeb-Regular.ttf"
)

=== src/plugins/genericprojectmanager/CMakeLists.txt ===
add_qtc_plugin(GenericProjectManager
  PLUGIN_CLASS GenericProjectPlugin
  PLUGIN_DEPENDS Core ProjectExplorer QtSupport TextEditor
  PLUGIN_TEST_DEPENDS CppEditor
  PLUGIN_RECOMMENDS CppEditor
  SOURCES ${TEST_SOURCES}
    genericmakestep.cpp genericmakestep.h
    genericproject.cpp genericproject.h
    genericprojectconstants.h
    genericprojectfileseditor.cpp genericprojectfileseditor.h
    genericprojectmanagertr.h
    genericprojectplugin.cpp
    genericprojectwizard.cpp genericprojectwizard.h
)

=== src/plugins/mercurial/CMakeLists.txt ===
add_qtc_plugin(Mercurial
  PLUGIN_DEPENDS Core TextEditor VcsBase
  SOURCES
    annotationhighlighter.cpp annotationhighlighter.h
    authenticationdialog.cpp authenticationdialog.h
    commiteditor.cpp commiteditor.h
    constants.h
    mercurialclient.cpp mercurialclient.h
    mercurialcommitwidget.cpp mercurialcommitwidget.h
    mercurialeditor.cpp mercurialeditor.h
    mercurialplugin.cpp
    mercurialsettings.cpp mercurialsettings.h
    mercurialtr.h
    revertdialog.cpp revertdialog.h
    srcdestdialog.cpp srcdestdialog.h
)

=== src/plugins/scxmleditor/CMakeLists.txt ===
add_qtc_plugin(ScxmlEditor
  INCLUDES common plugin_interface outputpane
  PLUGIN_DEPENDS Core ProjectExplorer QtSupport TextEditor
  SOURCES
    common/colorpicker.cpp common/colorpicker.h
    common/colorsettings.cpp common/colorsettings.h
    common/colorthemedialog.cpp common/colorthemedialog.h
    common/colorthemes.cpp common/colorthemes.h
    common/colorthemeview.cpp common/colorthemeview.h
    common/colortoolbutton.cpp common/colortoolbutton.h
    common/common.qrc
    common/dragshapebutton.cpp common/dragshapebutton.h
    common/graphicsview.cpp common/graphicsview.h
    common/magnifier.cpp common/magnifier.h
    common/mainwidget.cpp common/mainwidget.h
    common/movableframe.cpp common/movableframe.h
    common/navigator.cpp common/navigator.h
    common/navigatorgraphicsview.cpp common/navigatorgraphicsview.h
    common/navigatorslider.cpp common/navigatorslider.h
    common/search.cpp common/search.h
    common/searchmodel.cpp common/searchmodel.h
    common/shapegroupwidget.cpp common/shapegroupwidget.h
    common/shapestoolbox.cpp common/shapestoolbox.h
    common/sizegrip.cpp common/sizegrip.h
    common/stateproperties.cpp common/stateproperties.h
    common/stateview.cpp common/stateview.h
    common/statistics.cpp common/statistics.h
    common/statisticsdialog.cpp common/statisticsdialog.h
    common/structure.cpp common/structure.h
    common/structuremodel.cpp common/structuremodel.h
    common/treeview.cpp common/treeview.h
    outputpane/errorwidget.cpp outputpane/errorwidget.h
    outputpane/outputpane.h
    outputpane/outputtabwidget.cpp outputpane/outputtabwidget.h
    outputpane/tableview.cpp outputpane/tableview.h
    outputpane/warning.cpp outputpane/warning.h
    outputpane/warningmodel.cpp outputpane/warningmodel.h
    plugin_interface/actionhandler.cpp plugin_interface/actionhandler.h
    plugin_interface/actionprovider.h
    plugin_interface/attributeitemdelegate.cpp plugin_interface/attributeitemdelegate.h
    plugin_interface/attributeitemmodel.cpp plugin_interface/attributeitemmodel.h
    plugin_interface/baseitem.cpp plugin_interface/baseitem.h
    plugin_interface/connectableitem.cpp plugin_interface/connectableitem.h
    plugin_interface/cornergrabberitem.cpp plugin_interface/cornergrabberitem.h
    plugin_interface/eventitem.cpp plugin_interface/eventitem.h
    plugin_interface/finalstateitem.cpp plugin_interface/finalstateitem.h
    plugin_interface/genericscxmlplugin.cpp plugin_interface/genericscxmlplugin.h
    plugin_interface/graphicsitemprovider.h
    plugin_interface/graphicsscene.cpp plugin_interface/graphicsscene.h
    plugin_interface/highlightitem.cpp plugin_interface/highlightitem.h
    plugin_interface/historyitem.cpp plugin_interface/historyitem.h
    plugin_interface/idwarningitem.cpp plugin_interface/idwarningitem.h
    plugin_interface/imageprovider.cpp plugin_interface/imageprovider.h
    plugin_interface/initialstateitem.cpp plugin_interface/initialstateitem.h
    plugin_interface/initialwarningitem.cpp plugin_interface/initialwarningitem.h
    plugin_interface/isceditor.h
    plugin_interface/layoutitem.cpp plugin_interface/layoutitem.h
    plugin_interface/mytypes.h
    plugin_interface/parallelitem.cpp plugin_interface/parallelitem.h
    plugin_interface/quicktransitionitem.cpp plugin_interface/quicktransitionitem.h
    plugin_interface/scattributeitemdelegate.cpp plugin_interface/scattributeitemdelegate.h
    plugin_interface/scattributeitemmodel.cpp plugin_interface/scattributeitemmodel.h
    plugin_interface/sceneutils.cpp plugin_interface/sceneutils.h
    plugin_interface/scgraphicsitemprovider.cpp plugin_interface/scgraphicsitemprovider.h
    plugin_interface/scshapeprovider.cpp plugin_interface/scshapeprovider.h
    plugin_interface/scutilsprovider.cpp plugin_interface/scutilsprovider.h
    plugin_interface/scxmldocument.cpp plugin_interface/scxmldocument.h
    plugin_interface/scxmlnamespace.cpp plugin_interface/scxmlnamespace.h
    plugin_interface/scxmltag.cpp plugin_interface/scxmltag.h
    plugin_interface/scxmltagutils.cpp plugin_interface/scxmltagutils.h
    plugin_interface/scxmltypes.h
    plugin_interface/scxmluifactory.cpp plugin_interface/scxmluifactory.h
    plugin_interface/serializer.cpp plugin_interface/serializer.h
    plugin_interface/shapeprovider.cpp plugin_interface/shapeprovider.h
    plugin_interface/snapline.cpp plugin_interface/snapline.h
    plugin_interface/stateitem.cpp plugin_interface/stateitem.h
    plugin_interface/statewarningitem.cpp plugin_interface/statewarningitem.h
    plugin_interface/tagtextitem.cpp plugin_interface/tagtextitem.h
    plugin_interface/textitem.cpp plugin_interface/textitem.h
    plugin_interface/transitionitem.cpp plugin_interface/transitionitem.h
    plugin_interface/transitionwarningitem.cpp plugin_interface/transitionwarningitem.h
    plugin_interface/undocommands.cpp plugin_interface/undocommands.h
    plugin_interface/utilsprovider.cpp plugin_interface/utilsprovider.h
    plugin_interface/warningitem.cpp plugin_interface/warningitem.h
    plugin_interface/warningprovider.h
    scxmleditor_global.h
    scxmleditortr.h
    scxmleditorconstants.h
    scxmleditor.cpp scxmleditor.h
    scxmleditordocument.cpp scxmleditordocument.h
    scxmleditorplugin.cpp
    scxmltexteditor.cpp scxmltexteditor.h
)

=== src/libs/3rdparty/libvterm/CMakeLists.txt ===
add_qtc_library(libvterm STATIC
  PUBLIC_INCLUDES ${CMAKE_CURRENT_SOURCE_DIR}/include
  PROPERTIES QT_COMPILE_OPTIONS_DISABLE_WARNINGS ON
  SOURCES
    src/encoding.c
    src/fullwidth.inc
    src/keyboard.c
    src/mouse.c
    src/parser.c
    src/pen.c
    src/rect.h
    src/screen.c
    src/state.c
    src/unicode.c
    src/utf8.h
    src/vterm.c
    src/vterm_internal.h
)

=== PKGBUILD ===
# Maintainer: Alexey Pavlov <alexpux@gmail.com>
# Maintainer: Ray Donnelly <mingw.android@gmail.com>

_realname=qt-creator
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-docs"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-devel")
_base_ver=16.0.0
pkgver=${_base_ver/-/}
pkgrel=1
pkgdesc='Lightweight, cross-platform integrated development environment (mingw-w64)'
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.qt.io/product/development-tools'
msys2_repository_url="https://code.qt.io/cgit/qt-creator/qt-creator.git"
msys2_references=(
  'archlinux: qtcreator'
)
license=('spdx:GPL-3.0-or-later WITH Qt-GPL-exception-1.0')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-clang"
             "${MINGW_PACKAGE_PREFIX}-clang-tools-extra"
             "${MINGW_PACKAGE_PREFIX}-litehtml"
             "${MINGW_PACKAGE_PREFIX}-python"
             "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
             "${MINGW_PACKAGE_PREFIX}-qt6-tools"
             "${MINGW_PACKAGE_PREFIX}-qt6-svg"
             "${MINGW_PACKAGE_PREFIX}-qt6-quick3d"
             "${MINGW_PACKAGE_PREFIX}-qt6-serialport"
             "${MINGW_PACKAGE_PREFIX}-qt6-translations"
             "${MINGW_PACKAGE_PREFIX}-qt6-5compat"
             #"${MINGW_PACKAGE_PREFIX}-qt6-charts"
             "${MINGW_PACKAGE_PREFIX}-qt6-doc"
             "${MINGW_PACKAGE_PREFIX}-qt6-quicktimeline"
             "${MINGW_PACKAGE_PREFIX}-yaml-cpp")
install=qt-creator-${MSYSTEM}.install
_pkgfqn="${_realname}-opensource-src-${_base_ver}"
source=(https://download.qt.io/official_releases/qtcreator/${_base_ver%.*}/${_base_ver}/${_pkgfqn}.tar.xz
        qt-creator-3.2.0-Allow-iOS-plugin-on-any-platform.patch
        qt-creator-5.0.1-fix-library-archive-path.patch
        003-link-against-clang-cpp.patch
        005-rename-creator-libzip.patch)
sha256sums=('18b4353e68a31c062713008c05ce7f7ee88aaaf56d5ac0c6de579babfb2837da'
            'eacd98f69324695595690c5328d62137af609e55c7c94c19e7bd8e1f7e4b4712'
            '29d67f88f071abe7a4b589182767b8a697fe4e516d70707bfca88f035883718f'
            '5d6c0b626ef29ce39372eb180527d64e11af2bf39a1a3e84e709464a20d2433b'
            '417ef118818add39304ec36e4b3651d4fa238ed548cffeab42cbcf651a79294c')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd "${srcdir}"/${_pkgfqn}

  apply_patch_with_msg \
    qt-creator-3.2.0-Allow-iOS-plugin-on-any-platform.patch \
    qt-creator-5.0.1-fix-library-archive-path.patch \
    003-link-against-clang-cpp.patch \
    005-rename-creator-libzip.patch
}

build() {
  mkdir -p "${srcdir}"/build-${MSYSTEM} && cd "${srcdir}"/build-${MSYSTEM}

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  CXXFLAGS+=" -Wno-deprecated-declarations" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake.exe \
    -GNinja \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    "${_extra_config[@]}" \
    -DWITH_DOCS=ON \
    -DBUILD_DEVELOPER_DOCS=ON \
    -DBUILD_QBS=OFF \
    -DPython3_EXECUTABLE=${MINGW_PREFIX}/bin/python \
    -DWITH_TESTS=OFF \
    -DCLANGTOOLING_LINK_CLANG_DYLIB=ON \
    ../${_pkgfqn}

  ${MINGW_PREFIX}/bin/cmake --build .
  ${MINGW_PREFIX}/bin/cmake --build . --target docs
}

package_qt-creator() {
  pkgdesc="Lightweight, cross-platform integrated development environment (mingw-w64)"
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-declarative"
           "${MINGW_PACKAGE_PREFIX}-qt6-tools"
           "${MINGW_PACKAGE_PREFIX}-qt6-svg"
           "${MINGW_PACKAGE_PREFIX}-qt6-quick3d"
           "${MINGW_PACKAGE_PREFIX}-qt6-serialport"
           "${MINGW_PACKAGE_PREFIX}-qt6-translations"
           "${MINGW_PACKAGE_PREFIX}-qt6-5compat"
           "${MINGW_PACKAGE_PREFIX}-litehtml"
           "${MINGW_PACKAGE_PREFIX}-yaml-cpp"
           "${MINGW_PACKAGE_PREFIX}-zstd")
  optdepends=("${MINGW_PACKAGE_PREFIX}-gdb: for the debugger"
              "${MINGW_PACKAGE_PREFIX}-cmake: CMake project support"
              "${MINGW_PACKAGE_PREFIX}-ninja: Ninja Generator"
              "${MINGW_PACKAGE_PREFIX}-qbs: QBS project support"
              "${MINGW_PACKAGE_PREFIX}-clang-libs: ClangCodeModel and ClangFormat plugins"
              #"${MINGW_PACKAGE_PREFIX}-qt6-charts: Plugin AppStatisticsMonitor"
              "${MINGW_PACKAGE_PREFIX}-qt6-doc: integrated Qt6 documentation"
              "${MINGW_PACKAGE_PREFIX}-qt6-quicktimeline")

  cd "${srcdir}"/build-${MSYSTEM}

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  install -d "${pkgdir}${MINGW_PREFIX}"/share/licenses/${_realname}
  install -Dm644 "${srcdir}"/${_pkgfqn}/LICENSE* -t "${pkgdir}${MINGW_PREFIX}"/share/licenses/${_realname}
}

package_qt-creator-docs() {
  pkgdesc="Lightweight, cross-platform integrated development environment (documentation) (mingw-w64)"
  depends=()

  cd "${srcdir}"/build-${MSYSTEM}
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install . --component qch_docs
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install . --component html_docs
}

package_qt-creator-devel() {
  pkgdesc="Lightweight, cross-platform integrated development environment (development files) (mingw-w64)"
  depends=("${MINGW_PACKAGE_PREFIX}-${_realname}")

  cd "${srcdir}"/build-${MSYSTEM}
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install . --component Devel
}

# Please leave this block here as I use
# it to quickly make and test changes.
# return 0
# Debugger ProjectExplorer 
# ALLGOOD="yes"
# PLUGINS="Debugger"
# for PLUGIN in $PLUGINS; do
#   PLUGINLC=$(echo ${PLUGIN} | tr 'A-Z' 'a-z')
#   pushd src/build-${MSYSTEM}/src/plugins/${PLUGINLC}
#     PATH=${MINGW_PREFIX}/bin:"$PATH" cmake --build . || ALLGOOD="no"
#   popd
# done
# if [ "${ALLGOOD}" = "yes" ]; then
# (
#   QTCPID=$(ps --windows | grep creator | awk '{ print $1; }')
#   while [ -n "$QTCPID" ]; do
#     cmd.exe /c "taskkill /PID $QTCPID"
#     sleep 1
#     QTCPID=$(ps --windows | grep creator | awk '{ print $1; }')
#   done
#   for PLUGIN in $PLUGINS; do
#     PLUGINLC=$(echo ${PLUGIN} | tr 'A-Z' 'a-z')
#     pushd src/build-${MSYSTEM}/src/plugins/${PLUGINLC}
#       PATH=${MINGW_PREFIX}/bin:$PATH cmake --build .
#       cp ../../../lib/qtcreator/plugins/${PLUGIN}d.dll ${MINGW_PREFIX}/lib/qtcreator/plugins/
#     popd
#   done
#   PATH=${MINGW_PREFIX}/bin:$PATH ${MINGW_PREFIX}/bin/qtcreator &
#   )
# fi
# 

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
